
unit Unit4;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Buttons;

type
  tBarvyHracu = array [1..4] of Byte;

type
  TOptionsForm = class(TForm)
    Panel3: TPanel;
    Label2: TLabel;
    VyberPoctuHracu: TGroupBox;

    HraciButton2: TRadioButton;
    HraciButton4: TRadioButton;
    BarvaHrace1: TGroupBox;
    Color11: TRadioButton;
    Color12: TRadioButton;
    Color13: TRadioButton;
    Color14: TRadioButton;
    BarvaHrace2: TGroupBox;
    Color21: TRadioButton;
    Color23: TRadioButton;
    Color22: TRadioButton;
    Color24: TRadioButton;
    BarvaHrace3: TGroupBox;
    Color31: TRadioButton;
    Color33: TRadioButton;
    Color32: TRadioButton;
    Color34: TRadioButton;
    BarvaHrace4: TGroupBox;
    Color41: TRadioButton;
    Color43: TRadioButton;
    Color42: TRadioButton;
    Color44: TRadioButton;
    Panel2: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    GroupBox1: TGroupBox;
    CompRadioButton0: TRadioButton;
    CompRadioButton1: TRadioButton;
    CompRadioButton2: TRadioButton;
    CompRadioButton3: TRadioButton;
    CompRadioButton4: TRadioButton;
    BitBtn2: TBitBtn;
    BitBtn1: TBitBtn;
    DiffScrollBar: TScrollBar;
    DiffLabel1: TLabel;
    DiffLabel2: TLabel;
    DiffLabel3: TLabel;
    SpeedScrollBar: TScrollBar;
    Label1: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    procedure BitBtn2Click(Sender: TObject);
    procedure Color11Click(Sender: TObject);
    procedure HraciButton1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure CompRadioButton0Click(Sender: TObject);

  private
    { Private declarations }

  public
    { Public declarations }
    BarvyHracu: tBarvyHracu;
    PocetHr: Byte;
    PocetComp: Byte;
  end;


var
  OptionsForm: TOptionsForm;

implementation

{$R *.DFM}

procedure TOptionsForm.BitBtn2Click(Sender: TObject);
begin
 OptionsForm.Close;
end;

procedure TOptionsForm.Color11Click(Sender: TObject);
var
  i, NewCol, OldCol, CisloHrace: Byte;
begin
  With Sender as TRadioButton do
    begin
    {Na jakou barvicku to ma zmenit:    }
      NewCol := StrToInt (Name[7]);

    {A ktereho hrace k tomu doslo:      }
      CisloHrace := StrToInt (Parent.Name [11]);

    {A z jake barvicky:                 }
      OldCol := BarvyHracu [CisloHrace];
    end;

  for i := 1 to 4 do
    if i <> CisloHrace then
      if BarvyHracu [i] = NewCol then
        begin  {uz vime kde se to ma jeste zmenit :-)}
          {Prehozeni zaskrtnuti}
          with FindComponent ('Color' + IntToStr (i) + IntToStr (OldCol))
            as TRadioButton do Checked := true;
          BarvyHracu [i] := OldCol;
          BarvyHracu [CisloHrace] := NewCol;
          exit;
        end    {uz vime kde se to ma jeste zmenit :-)}
end;


procedure TOptionsForm.HraciButton1Click(Sender: TObject);
var
  i: Byte;
begin
{Zjisti se pocet hracu -- PocetHr}
  With Sender as TRadioButton do
    PocetHr := StrToInt (Name[Length(Name)]);

{Povoli se maximalne PocetHr pocitacovych hracu a taktez stejny pocet
 menicu barvicek}
  for i := 1 to PocetHr do
    begin
    {Pocet comp}
      (FindComponent ('CompRadioButton'+IntToStr (i))
         as TRadioButton).Enabled := True;
    {Menice barvicek}
      (FindComponent ('BarvaHrace'+IntToStr (i))
         as TGroupBox).Visible := True;
    end;

{Pokud byl nastaven vetsi pocet pocitacu, snizi se}
  if PocetComp > PocetHr then
    begin
      PocetComp := PocetHr;
      (FindComponent ('CompRadioButton'+IntToStr (PocetHr))
        as TRadioButton).Checked := True
    end;

{No a zakazou se ty dalsi (nemozne) moznosti poctu computeru a barvicek}
  if PocetHr < 4 then
    for i := PocetHr + 1 to 4 do
      begin
    {Pocet comp}
        (FindComponent ('CompRadioButton'+IntToStr (i))
           as TRadioButton).Enabled := False;
    {Menice barvicek}
        (FindComponent ('BarvaHrace'+IntToStr (i))
           as TGroupBox).Visible := False;
      end;

end;

procedure TOptionsForm.FormActivate(Sender: TObject);
var
  i: Byte;
begin
  {nastaveni barvicek hracu (aby si odpovidaly)}
  for i := 1 to 4 do
    begin
      BarvyHracu[i] := i;
      (FindComponent('Color'+IntToStr (i*10+i))
        as TRadioButton).Checked := True;
    end;

  {nastaveni dalsich konstant}
  PocetComp := 1;
  PocetHr := 2;
  (FindComponent('CompRadioButton'+IntToStr (PocetComp))
        as TRadioButton).Checked := True;

  (FindComponent('HraciButton'+IntToStr (PocetHr))
        as TRadioButton).Checked := True;

end;

procedure TOptionsForm.CompRadioButton0Click(Sender: TObject);
var
  Enabl: Boolean;
begin
  PocetComp := StrToInt ((Sender as TRadioButton).Name[16]);
  if StrToInt ((Sender as TRadioButton).Name[16]) = 0 then
    Enabl := False
  else
    Enabl := True;

  DiffScrollBar.Enabled := Enabl;
  DiffLabel1.Enabled := Enabl;
  DiffLabel2.Enabled := Enabl;
  DiffLabel3.Enabled := Enabl;
end;

end.
