unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Buttons, Menus, Unit2, Unit3, Unit4,
  Unit5;

const
  MaxPlayers = 4;  {maximalni pocet hracu}
  MaxLevel = 6;
type
  tPlayerColor = array [1..MaxPlayers] of tColor;
  tTypeOfPlayer = (Comp, User);
  tPlayers = array [1..maxPlayers] of tTypeOfPlayer;
const
  MaxDim = 9;     {pocet tlacitek (= pocet radku = pocet sloupcu)}
  ConstPlayerColor : tPlayerColor = (clBlue, clRed, clLime, clYellow);
type
  tPlayer = 0..MaxPlayers;
  tIndex = 0..MaxDim;
  TMainForm = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Button00: TButton;
    Button01: TButton;
    Button02: TButton;
    Button03: TButton;
    Button04: TButton;
    Button05: TButton;
    Button06: TButton;
    Button07: TButton;
    Button08: TButton;
    Button09: TButton;
    Panel3: TPanel;
    Panel5: TPanel;
    Button11: TButton;
    Button12: TButton;
    Button13: TButton;
    Button14: TButton;
    Button15: TButton;
    Button16: TButton;
    Button17: TButton;
    Button18: TButton;
    Button19: TButton;
    Button21: TButton;
    Button22: TButton;
    Button23: TButton;
    Button24: TButton;
    Button25: TButton;
    Button26: TButton;
    Button27: TButton;
    Button28: TButton;
    Button29: TButton;
    Button31: TButton;
    Button32: TButton;
    Button33: TButton;
    Button34: TButton;
    Button35: TButton;
    Button36: TButton;
    Button37: TButton;
    Button38: TButton;
    Button39: TButton;
    Button10: TButton;
    Button41: TButton;
    Button42: TButton;
    Button43: TButton;
    Button44: TButton;
    Button45: TButton;
    Button46: TButton;
    Button47: TButton;
    Button48: TButton;
    Button49: TButton;
    Button20: TButton;
    Button51: TButton;
    Button52: TButton;
    Button53: TButton;
    Button54: TButton;
    Button55: TButton;
    Button56: TButton;
    Button57: TButton;
    Button58: TButton;
    Button59: TButton;
    Button61: TButton;
    Button62: TButton;
    Button63: TButton;
    Button64: TButton;
    Button65: TButton;
    Button66: TButton;
    Button67: TButton;
    Button68: TButton;
    Button69: TButton;
    Button71: TButton;
    Button72: TButton;
    Button73: TButton;
    Button74: TButton;
    Button75: TButton;
    Button76: TButton;
    Button77: TButton;
    Button78: TButton;
    Button79: TButton;
    Button81: TButton;
    Button82: TButton;
    Button83: TButton;
    Button84: TButton;
    Button85: TButton;
    Button86: TButton;
    Button87: TButton;
    Button88: TButton;
    Button89: TButton;
    Button91: TButton;
    Button92: TButton;
    Button93: TButton;
    Button94: TButton;
    Button95: TButton;
    Button96: TButton;
    Button97: TButton;
    Button98: TButton;
    Button99: TButton;
    Button30: TButton;
    Button40: TButton;
    Button50: TButton;
    Button60: TButton;
    Button70: TButton;
    Button80: TButton;
    Button90: TButton;
    BackGroundImage: TImage;
    PlayerPanel1: TPanel;
    PlayerLabel1: TLabel;
    ScoreLabel1: TLabel;
    PlayerPanel2: TPanel;
    PlayerLabel2: TLabel;
    ScoreLabel2: TLabel;
    PlayerPanel3: TPanel;
    PlayerLabel3: TLabel;
    ScoreLabel3: TLabel;
    PlayerPanel4: TPanel;
    PlayerLabel4: TLabel;
    ScoreLabel4: TLabel;
    BitBtn1: TBitBtn;
    MainMenu1: TMainMenu;
    Hra1: TMenuItem;
    Informace1: TMenuItem;
    NewGameMenuItem: TMenuItem;
    N1: TMenuItem;
    Konec1: TMenuItem;
    N2: TMenuItem;
    Npovda1: TMenuItem;
    Nastaveni1: TMenuItem;
    Timer1: TTimer;
    Label1: TLabel;
    LevelLabel: TLabel;
    procedure Button00Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure AddPoints (Who: tPlayer; HowMuch: ShortInt);
    procedure NextPlayer;
    function ChangeLine (Index: tIndex; Enabl: Boolean): Boolean;
    function ChangeColum (Index: tIndex; Enabl: Boolean): Boolean;
    procedure NextLevel;
    procedure SetNextFocus;
    procedure GameInit;
    procedure NewGameMenuItemClick(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure Nastaveni1Click(Sender: TObject);
    function MaxOfLine (Index: tIndex): ShortInt;
    function MaxOfColum (Index: tIndex): ShortInt;
    procedure ComputerPlay;
    procedure Timer1Timer(Sender: TObject);
    procedure Npovda1Click(Sender: TObject);
    procedure Konec1Click(Sender: TObject);
  private
    { Private declarations }
    Player: tPlayer;
    Players: tPlayers;
    NCompPlayer: tPlayer;
    NPlayer: tPlayer;
    PlayerColor: tPlayerColor;
    X,Y: tIndex;
    Level: Byte;
    Diff: Byte;  {obtiznost}
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}
{##############################################################################}
{##############################################################################}
{##############################################################################}

{--------------------------  AddPoints  ---------------------------------------}
procedure TMainForm.AddPoints (Who: tPlayer; HowMuch: ShortInt);
var
  Score: String;
begin {AddPoints}
  Score := (FindComponent ('ScoreLabel' + IntToStr (Who)) as TLabel).Caption;
  Score := IntTostr (HowMuch + StrToInt (Score));
  (FindComponent ('ScoreLabel' + IntToStr (Who)) as TLabel).Caption := Score;
end;  {AddPoints}

{--------------------------  NextPlayer  --------------------------------------}
procedure TMainForm.NextPlayer;
var
  EndOfGame: Boolean;
begin {NextPlayer}
  EndOfGame := False;
 { LICHY hrac vybira z  RADKU,
   SUDY  hrac vybira ze SLOUPCE }

  {zakazani drive pouziteho sloupce (radku)}
  if Odd (Player) then ChangeLine (Y, False)
  else ChangeColum (X, False);

  {Odstraneni zvyrazneni aktivniho hrace}
  (FindComponent ('PlayerPanel' + IntTostr (Player)) as TPanel).
    Color := clBtnFace;

  {Vlastni prepnuti na dalsiho hrace}
  if Player = NPlayer then Player := 1
  else Inc (Player);


  {Povoleni radku (sloupce), ze ktereho se bude vybirat}
  if Odd (Player) then
    EndOfGame := Not ChangeLine (Y, True)
  else
    EndOfGame := Not ChangeColum (X, True);

  {kontrola, zda jsme jiz neskoncili}
  if EndOfGame then
    begin
      NextLevel;
      Exit;
    end;

  {Zviditelneni prave hrajiciho hrace}
  (FindComponent ('PlayerPanel' + IntTostr (Player)) as TPanel).
    Color := PlayerColor[Player];

  {Nastavi se aktivni tlacitko}
  SetNextFocus;

  {Pokud hraje pocitac....chvilku se ceka...}
  if Players[Player] = Comp then {ComputerPlay;}
    Timer1.Enabled := True;
end;  {NextPlayer}

{---------------------------  ChangeLine  -------------------------------------}
function TMainForm.ChangeLine (Index: tIndex; Enabl: Boolean): Boolean;
var
  i: Byte;
begin {ChangeLine}
  Result := False;
  for i := 0 to 9 do
    begin
      if (FindComponent ('Button' + IntToStr (Index) + IntToStr (i)) as TButton).
        Visible then Result := True;
      (FindComponent ('Button' + IntToStr (Index) + IntToStr (i)) as TButton).
        Enabled := Enabl;
    end;
end;  {ChangeLine}

{---------------------------  ChangeColum  -------------------------------------}
function TMainForm.ChangeColum (Index: tIndex; Enabl: Boolean): Boolean;
var
  i: Byte;
begin {ChangeColum}
  Result := False;
  for i := 0 to 9 do
    begin
      if (FindComponent ('Button' + IntToStr (Index) + IntToStr (i)) as TButton).
        Visible then Result := True;
      (FindComponent ('Button' + IntToStr (i) + IntToStr (Index)) as TButton).
        Enabled := Enabl;
    end;
end;  {ChangeColum}


{-------------------------  Button00Click  ------------------------------------}
procedure TMainForm.Button00Click(Sender: TObject);
var
  HowMuch: ShortInt;
  Name: String;
begin {Button00Click}
  Name := (Sender as TButton).Name;
  X := StrToInt (Name[Length (Name)]);
  Y := StrToInt (Name[Length (Name)-1]);

  {Odstrani se tlacitko}
  (Sender as TButton).Visible := False;
  BackgroundImage.Update;

  HowMuch := StrToInt ((Sender as TButton).Caption);

  {pripise skore}
  AddPoints (Player, HowMuch);

  {A je na rade dalsi player}
  NextPlayer;
end;  {Button00Click}


{-----------------------------  FormCreate  -----------------------------------}
procedure TMainForm.FormCreate(Sender: TObject);
var
  i, j: Byte;
  Number : ShortInt;
begin {FormCreate}
  Randomize;
  NPlayer := 2;
  NCompPlayer := 0;
  Level := 1;
  PlayerColor := ConstPlayerColor;
  Timer1.Interval := 50;
end;  {FormCreate}

{-------------------------  NextLevel  ----------------------------------------}
procedure TMainForm.NextLevel;
var
  i,j, Vitez: ShortInt;
  Pom, Pom2: Integer;
  Fil: file;

begin {NextLevel}
  {Odstrani se vsechny buttonky z hraciho pole, aby bylo videt cely obrazek}
  for i := 0 to MaxDim do
    for j := 0 to MaxDim do
      begin
        (FindComponent ('Button' + IntToStr (i) + IntToStr (j)) as TButton).
           Visible := False;
        BackgroundImage.Update;
      end;

  {Zjisti se vitez}
  Pom := StrToInt (Scorelabel1.Caption);
  Vitez := 1;

  for i := 1 to NPlayer do
    begin {For}
      Pom2 := StrToInt ((FindComponent ('Scorelabel' + IntToStr (i))
        as TLabel).Caption);
      if Pom < Pom2 then
        begin
          Pom := Pom2;
          Vitez := i;
        end;
    end;  {For}

 WinnerForm.WinnerLabel.Caption := (FindComponent ('PlayerLabel' +
   IntToStr (Vitez)) as TLabel).Caption;
 WinnerForm.WinnerPanel.Color := PlayerColor [Vitez];
 if WinnerForm.ShowModal = mrNo then Close;
 {ELSE  ....jdeme do dalsiho levelu!}

 {Zjisti se, zda je tam obrazek do dalsiho levelu neni-li zacina se opet od
  1.levelu}
 AssignFile(Fil, 'Level' + IntToStr (Level + 1) + '.BMP');
 {$I-}
 Reset(Fil);
 {$I+}
 if IOResult = 0 then
   Inc (Level)
 else
   Level := 1;
 GameInit;
end;  {NextLevel}

{-------------------------  SetNextFocus  -------------------------------------}
procedure TMainForm.SetNextFocus;
var
  XX, YY: Byte;
begin {SetNextFocus}
  XX := 0;
  YY := 0;

  if Odd (Player) then
    begin
      YY := Y;
      while not ((FindComponent ('Button' + IntToStr (YY) + IntToStr (XX))
        as TButton).Visible) and (XX<=MaxDim) do Inc (XX);
    end
  else
    begin
      XX := X;
      while not ((FindComponent ('Button' + IntToStr (YY) + IntToStr (XX))
        as TButton).Visible) and (YY<=MaxDim) do Inc (YY);
    end;

  if (XX > MaxDim) or (YY > MaxDim) then Exit;
  (FindComponent ('Button' + IntToStr (YY) + IntToStr (XX)) as TButton).
    SetFocus;
end;  {SetNextFocus}


{----------------------------  GameInit  --------------------------------------}
procedure TMainForm.GameInit;
var
  Number,i,j: ShortInt;
  Enabl: Boolean;
begin {GameInit}
{Zakazani (povoleni) hracu, kteri nehraji (hraji)}
if NPlayer = 2 then Enabl := False else Enabl := True;
for i := 3 to 4 do
  begin
    (FindComponent ('PlayerLabel' + IntToStr (i)) as TLabel).Enabled := Enabl;
    (FindComponent ('ScoreLabel' + IntToStr (i)) as TLabel).Enabled := Enabl;
  end;

{Ocislovani, zakazani a zviditelneni buttonku}
  for i := 0 to 9 do
    for j := 0 to 9 do
      begin
        Number := Random (19);
        Number := Number - 9;
        BackgroundImage.Update;
        with (FindComponent ('Button' + IntToStr (i) + IntToStr (j)) as TButton)
          do
            begin
              Caption := IntToStr (Number);
              Visible := True;
              Enabled := False;
            end;
      end;
  {Nahrati obrazku do pozadi}
  BackGroundImage.Picture.LoadFromFile ('Level' + IntToStr (Level) + '.BMP');

  Player := 1;
  for i := 1 to NPlayer - NCompPlayer do
    Players[i] := User;
  for i := NPlayer - NCompPlayer + 1 to NPlayer do
    Players[i] := Comp;


  X := MaxDim div 2;
  Y := MaxDim div 2;

  {Vynulovani scorat}
  for i := 1 to MaxPlayers do
    (FindComponent ('ScoreLabel' + IntToStr (i)) as TLabel).Caption := '0';
  {Vypsani cisla Levelu}
  LevelLabel.Caption := IntToStr (Level);

  {Povoleni radku (sloupce), ze ketereho se bude vybirat}
  if Odd (Player) then ChangeLine (Y, True)
  else ChangeColum (X, True);

 (FindComponent ('PlayerPanel' + IntTostr (Player)) as TPanel).
   Color := PlayerColor[Player];

 SetNextFocus;
 if Players[Player] = Comp then Timer1.Enabled := True;
end;  {GameInit}


procedure TMainForm.NewGameMenuItemClick(Sender: TObject);
begin
  Timer1.Enabled := False;
  GameInit;
end;

procedure TMainForm.N2Click(Sender: TObject);
var
  Tim: Boolean;
begin
  Tim := Timer1.Enabled;
  Timer1.Enabled := False;

  AboutBox.ShowModal;

  Timer1.Enabled := Tim;
end;

procedure TMainForm.Nastaveni1Click(Sender: TObject);
var
  i: Byte;
begin
  Timer1.Enabled := False;

  if OptionsForm.ShowModal = mrCancel then Close;

  NPlayer := OptionsForm.PocetHr;
  for i := 1 to MaxPlayers do
    PlayerColor[i] := ConstPlayerColor[OptionsForm.BarvyHracu[i]];

  {Nastaveni Rychlosti}
  Timer1.Interval := 201 - OptionsForm.SpeedScrollBar.Position;

  NCompPlayer := OptionsForm.pocetComp;
  Diff := OptionsForm.DiffScrollBar.Position;
  Level := 1;
  GameInit;
end;

{--------------------------  MaxOfLine  ---------------------------------------}
function TMainForm.MaxOfLine (Index: tIndex): ShortInt;
var
  i: Byte;
  MyMax : ShortInt;
begin {MaxOfLine}
  MyMax := - MaxDim - 2; {Nejmensi cifra}
  for i := 0 to MaxDim do
   with (FindComponent ('Button' + IntToStr (Index) + IntToStr (i)) as TButton) do
     if Visible then
       if StrToInt (Caption) >= MyMax Then MyMax := StrToInt (Caption);
  Result := MyMax;
end;  {MaxOfLine}

{--------------------------  MaxOfColum  --------------------------------------}
function TMainForm.MaxOfColum (Index: tIndex): ShortInt;
var
  i: Byte;
  MyMax : ShortInt;
begin {MaxOfColum}
  MyMax := - MaxDim - 2; {Nejmensi cifra}
  for i := 0 to MaxDim do
   with (FindComponent ('Button' + IntToStr (i) + IntToStr (Index)) as TButton) do
     if Visible then
       if StrToInt (Caption) >= MyMax Then MyMax := StrToInt (Caption);
  Result := MyMax;
end;  {MaxOfColum}

{-------------------------  ComputerPlay  -------------------------------------}
procedure TMainForm.ComputerPlay;
var
  YY,XX: Byte;
  Rozdil,MyMax: ShortInt;
  i, Posice: tIndex;
begin {ComputerPlay}
  {vybere se nejlepsi tlacitko a klikne se na nej .... that's all!!}
  {vybereme prvni povolene}
  XX := 0;
  YY := 0;
  MyMax := -2*MaxDim - 4;

  if Odd (Player) then
    begin {Lichy - vybira z radku}
      YY := Y;
      for i := 0 to MaxDim do
        with FindComponent ('Button' + IntToStr (YY) + IntToStr (i)) as TButton do
          if Visible then
            begin
              Case Diff of
                1: {Nejlehci - vybere pouze nejvyssi cislo}
                  Rozdil := StrToInt (Caption);
                2..9: {Stredni obtiznnost - da se tam nejaka odchylka (+-5..1)}
                  Rozdil := StrToInt (Caption) - MaxOfColum (i) +
                    Random (10 - Diff + 1) - (5 - (Diff div 2));
                10: {Nejtezsi - diva se take z ceho bude tahnout protihrac}
                  Rozdil := StrToInt (Caption) - MaxOfColum (i);
                end; {case}
              if Rozdil >= MyMax then
                begin
                  MyMax := Rozdil;
                  XX := i;
                end;
            end;
    end   {Lichy - vybira z radku}
  else
    begin {Sudy - vybira ze sloupce}
      XX := X;
      for i := 0 to MaxDim do
        with FindComponent ('Button' + IntToStr (i) + IntToStr (XX)) as TButton do
          if Visible then
            begin
              Case Diff of
                1: {Nejlehci - vybere pouze nejvyssi cislo}
                  Rozdil := StrToInt (Caption);
                2..9: {Stredni obtiznnost - da se tam nejaka odchylka (+-5..1)}
                  Rozdil := StrToInt (Caption) - MaxOfColum (i) +
                    Random (10 - Diff + 1) - (5 - (Diff div 2));
                10: {Nejtezsi - diva se take z ceho bude tahnout protihrac}
                  Rozdil := StrToInt (Caption) - MaxOfColum (i);
                end; {case}
              if Rozdil >= MyMax then
                begin
                  MyMax := Rozdil;
                  YY := i;
                end;
            end;
    end; {Sudy - vybira ze sloupce}

  Button00Click (FindComponent ('Button' + IntToStr (YY) + IntToStr (XX))
    as TButton);
end;  {ComputerPlay}




procedure TMainForm.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := False;
  ComputerPlay;
end;

procedure TMainForm.Npovda1Click(Sender: TObject);
var
  Tim: Boolean;
begin
  Tim := Timer1.Enabled;
  Timer1.Enabled := False;
  RulesForm.ShowModal;
  Timer1.Enabled := Tim;
end;

procedure TMainForm.Konec1Click(Sender: TObject);
begin
  Close;
end;

end.
